# -*- coding: cp1252 -*-
import sys
if sys.version[0]=='3':#dtection version python 3 ou 2
    from tkinter import*
elif sys.version[0]=='2':
    from Tkinter import*
from math import *
class Application(Tk):
    def __init__(self,xmin,xmax,ymin,ymax):
        Tk.__init__(self)
        self.xmin,self.xmax=float(xmin),float(xmax)   #amplitude de la fenetre en abscisse
        self.ymin,self.ymax=float(ymin),float(ymax)   #idem en ordonne
        if self.xmin>self.xmax:
            self.xmin,self.xmax=self.xmax,self.xmin
        if self.ymin>self.ymax:
            self.ymin,self.ymax=self.ymax,self.ymin
        self.dx=self.xmax-self.xmin
        self.dy=self.ymin-self.ymax
        self.r=1.5  #rayon d'un point
        self.H=600  #hauteur de la fenetre
        self.L=600  #largeur
        self.width=1 #paisseur des traits
        self.epaisgrad=3 #hauteur des traits de graduation
        self.title('Graphique')
        self.can=Canvas(self,width=self.L,height=self.H,bg="white")
        self.can.configure(relief=SUNKEN)
        self.can.pack(padx=5,side=RIGHT)
        self.qUITter = Button(self,text='Quitter',command=self.quit)
        self.qUITter.pack()
        self.dico={}
        self.dico['noir']='#000000'
        self.dico['bleu']='#4040ff'
        self.dico['vert']='#009f50'
        self.dico['orange']='#ff641a'
        self.dico['violet']='#9122ff'
        self.dico['rose']='#ff79bc'
        self.dico['rouge']='#e1031e'
        self.dico['jaune']='#f2fe0a'
        
    def convertgraph(self,x,y):
        #convertit une coordonne graphique en coordonne pixel
        #retourne une liste
        a=(x-self.xmin)*self.L/self.dx
        b=(y-self.ymax)*self.H/self.dy
        l=[a,b]
        return l
    def fINIR():
        self.destroy()
    
    def point(self,x,y,couleur):
        #place un point de coordonnes graphique (x,y)
        l=self.convertgraph(x,y)
        self.can.create_oval(l[0]-self.r,l[1]-self.r,l[0]+self.r,l[1]+self.r,fill=self.dico[couleur],width=self.width)
    def segment(self,x1,y1,x2,y2,couleur):
        l1=self.convertgraph(x1,y1)
        l2=self.convertgraph(x2,y2)
        self.can.create_line(l1,l2,fill=self.dico[couleur],width=self.width)
    def traceaxe(self,x1,y1,x2,y2,grad,coul):
        #x1,y1,x2,y2 sont des coordonnes pixel
        #
        xdep,ydep,xfin,yfin=x1,y1,x2,y2
        res=grad
        if ydep==yfin: #axe horizontal
            self.can.create_line(xdep,ydep,xfin,yfin,fill=self.dico[coul],width=1,arrow=LAST)
            #graduations
            depgrad=floor(self.xmin/res)*res
            if depgrad!=self.xmin:
                depgrad=depgrad+res
            fingrad=floor(self.xmax/res)*res
            l=[]
            k=depgrad      
            while k<=fingrad: #graduations
                l.append(self.convertgraph(k,0)[0])
                k=k+res
            for p in l:
                self.can.create_line(p,ydep-self.epaisgrad,p,ydep+self.epaisgrad,fill=self.dico[coul],width=1)
            
            if self.ymin==0:
                self.can.create_text(xdep+4,ydep-self.epaisgrad-4,text=str(self.xmin),anchor=W,fill='black')#textes
                self.can.create_text(xfin-4,ydep-self.epaisgrad-4,text=str(self.xmax),anchor=E,fill='black')#idem
            else:
                self.can.create_text(xdep+4,ydep+self.epaisgrad+4,text=str(self.xmin),anchor=W,fill='black')#textes
                self.can.create_text(xfin-4,ydep+self.epaisgrad+4,text=str(self.xmax),anchor=E,fill='black')#idem
        if xdep==xfin: #axe vertical
            self.can.create_line(xdep,ydep,xfin,yfin,fill=self.dico[coul],width=1,arrow=LAST)
            #graduations
            depgrad=floor(self.ymin/res)*res
            if depgrad!=self.ymin:
                depgrad=depgrad+res
            fingrad=floor(self.ymax/res)*res
            l=[]
            k=depgrad      
            while k<=fingrad: #graduations
                l.append(self.convertgraph(0,k)[1])
                k=k+res
            for p in l: #graduations
                self.can.create_line(xdep-self.epaisgrad,p,xdep+self.epaisgrad,p,fill=self.dico[coul],width=1)
            self.can.create_text(xdep+4,ydep-self.epaisgrad-3,text=str(self.ymin),anchor=W,fill='black')
            self.can.create_text(xfin+2,yfin+self.epaisgrad+3,text=str(self.ymax),anchor=W,fill='black')
    def axes(self,gradx,grady,coul):
        l=self.convertgraph(0,0)
        if (self.xmin*self.xmax<=0): #axe vertical
            self.traceaxe(l[0],self.H,l[0],0,grady,coul)
        if (self.ymin*self.ymax<=0): #axe horizontal
            self.traceaxe(0,l[1],self.L,l[1],gradx,coul)
    def cercle_cr(self,x,y,rayon,couleur):
        r=rayon
        if r==0:
            self.point(x,y,couleur)
        if r>0:
            
            c1=self.convertgraph(x-r,y-r)
            c2=self.convertgraph(x+r,y+r)
            self.can.create_oval(c1[0],c1[1],c2[0],c2[1],outline=self.dico[couleur],width=self.width)
    


  
#*******************************************

def fenetre(xmin,xmax,ymin,ymax):
    global APp
    APp=Application(xmin,xmax,ymin,ymax)
    
def point(x,y,couleur='noir'):
    global APp
    APp.point(x,y,couleur)
def segment(x1,y1,x2,y2,couleur='noir'):
    global APp
    APp.segment(x1,y1,x2,y2,couleur)
def axes(gradx=1,grady=1,couleur='rouge'):
    global APp
    APp.axes(gradx,grady,couleur)
def cercle_cr(x,y,r,couleur='noir'):
    global APp
    APp.cercle_cr(x,y,r,couleur)
def cercle_cp(xc,yc,xp,yp,couleur='noir'):
    global APp
    r=sqrt((xp-xc)**2+(yp-yc)**2)
    APp.cercle_cr(xc,yc,r,couleur)
def affiche():
    APp.mainloop()
    APp.destroy()










